      SUBROUTINE ephinitu (unit,ierr)
      IMPLICIT DOUBLE PRECISION (a-h,o-z)

      INCLUDE  'ephihdr.inc'
      INCLUDE  'ephi.inc'

      COMMON /deb/ debug
      LOGICAL debug

      INTEGER idir
      INTEGER mjd
      INTEGER unit, ierr
      INTEGER i,j
      DOUBLE PRECISION sod
      DOUBLE PRECISION vec(3), corr
      CHARACTER*100 ephstr
  
      nv=0
      nvoff= 0
      nvrot= 0
      nveop= 0
      ierr= 0
   10 READ (unit,20,end=120) ephstr
CC	if (ephstr(1:1).eq.'H') write (*,20)ephstr
CC	write (*,20)ephstr
   20 FORMAT (a100)
CC      write(*,*) '[',ephstr,']'

      IF (ephstr(1:2).eq.'h1' .OR. ephstr(1:2).eq.'H1') THEN
        READ (ephstr,30,err=100) version, eph_source,
     &     epyear,epmon,epday,ephour,eph_seq,eph_notes
        if (debug) WRITE (*,*) eph_source,':',eph_notes
   30   FORMAT (7x,i2,1x,a4,1x,i4,1x,i2,1x,i2,1x,i2,1x,i5,1x,a10)

      ELSE IF (ephstr(1:2).eq.'h2' .OR. ephstr(1:2).eq.'H2') THEN
        READ (ephstr,40,err=100) cospar_id,sic,norad,
     &    sttpyear,sttpmonth,sttpday,sttphour,sttpmin,sttpsec,
     &    endpyear,endpmonth,endpday,endphour,endpmin,endpsec,
     &    ephsep,compat,tar_type,ref_frame,rot_type
   40   FORMAT (3x,i8,1x,i4,1x,i8,1x,2(i4,5(1x,i2),1x),i5,1x,i1,
     &   1x,i1,1x,i2, 1x,i1)

      ELSE IF (ephstr(1:2).eq.'h3' .OR. ephstr(1:2).eq.'H3') THEN
        READ (ephstr,50,err=100) atrk_ro_0,xtrk_ro_0,rtrk_ro_0,
     x   atrk_ro_1,xtrk_ro_1,rtrk_ro_1,atrk_ro_2,xtrk_ro_2,rtrk_ro_2
   50   FORMAT (2x,9(1x,i5))

      ELSE IF (ephstr(1:2).eq.'h4' .OR. ephstr(1:2).eq.'H4') THEN
        READ (ephstr,60,err=100) prf,xpond_xmit_delay,xpond_utc_off,
     x   xpond_osc_drift
   60   FORMAT (3x,f12.5,1x,f10.4,2(1x,f11.2))

      ELSE IF (ephstr(1:2).eq.'h9' .OR. ephstr(1:2).eq.'H9') THEN

      ELSE IF (ephstr(1:2).eq.'10' ) THEN
        IF (nv.gt.MAXENT) THEN
          WRITE (*,*) 'ephemeris read error: too many records'
          GO TO 110
        END IF
        READ (ephstr(3:100),*,err=100) idir,mjd,sod,leapflag(nv),
     &       (vec(k),k=1,3)
        IF (idir .eq. 1 .or. idir .eq. 0) nv=nv+1
        jdi(nv)=mjd+2400000.0d0
        jdf(nv)=sod/86400.d0+0.5d0
        IF (jdf(nv).ge.1.0d0) THEN
          jdi(nv)=jdi(nv)+1.0d0
          jdf(nv)=jdf(nv)-1.0d0
        END IF
        IF (idir .eq. 1 .or. idir .eq. 0) THEN
          outv(nv,1)= vec(1)
          outv(nv,2)= vec(2)
          outv(nv,3)= vec(3)

C In case there is not back vector (e.g., satellites)...
          backv(nv,1)= -outv(nv,1)
          backv(nv,2)= -outv(nv,2)
          backv(nv,3)= -outv(nv,3)
        ELSE IF (idir .eq. 2) THEN
          backv(nv,1)= vec(1)
          backv(nv,2)= vec(2)
          backv(nv,3)= vec(3)
C Be sure out and back are opposite directions.
          IF (backv(nv,1)*outv(nv,1) .gt. 0.d0) THEN
            backv(nv,1)= -backv(nv,1)
            backv(nv,2)= -backv(nv,2)
            backv(nv,3)= -backv(nv,3)
          ENDIF
        ENDIF
      ELSE IF (ephstr(1:2).eq.'20') THEN
        READ (ephstr(3:100),*,err=100) idir, (vec(k),k=1,3)
        IF (idir .eq. 1) THEN
          outv(nv,4)= vec(1)
          outv(nv,5)= vec(2)
          outv(nv,6)= vec(3)
C In case there is not back vector (e.g., satellites)...
          backv(nv,4)= -outv(nv,4)
          backv(nv,5)= -outv(nv,5)
          backv(nv,6)= -outv(nv,6)
        ELSE IF (idir .eq. 2) THEN
          backv(nv,4)= vec(1)
          backv(nv,5)= vec(2)
          backv(nv,6)= vec(3)
C Be sure out and back are opposite directions.
          IF (backv(nv,1)*outv(nv,1) .gt. 0.d0) THEN
            backv(nv,4)= -backv(nv,4)
            backv(nv,5)= -backv(nv,5)
            backv(nv,6)= -backv(nv,6)
          ENDIF
        ENDIF

      ELSE IF (ephstr(1:2).eq.'30') THEN
        READ (ephstr(3:100),*,err=100) idir, (vec(k),k=1,3),corr
        IF (idir .eq. 1) THEN
          aberoutv(nv,1)= vec(1)
          aberoutv(nv,2)= vec(2)
          aberoutv(nv,3)= vec(3)
          c12(nv)= corr

C In case there is no return information...
          aberbackv(nv,1)= -aberoutv(nv,1)
          aberbackv(nv,2)= -aberoutv(nv,2)
          aberbackv(nv,3)= -aberoutv(nv,3)
          c23(nv)= -c12(nv)
        ELSE IF (idir .eq. 2) THEN
          aberbackv(nv,1)= vec(1)
          aberbackv(nv,2)= vec(2)
          aberbackv(nv,3)= vec(3)
          c23(nv)= corr

C  WEAK TEST: REDO THIS!
          if (c23(nv)*c12(nv) .gt. 0.d0) c23(nv)= -c23(nv)
        ENDIF

      ELSE IF (ephstr(1:2).eq.'40') THEN
        READ (ephstr(3:100),*,err=100) oscrelcorr

      ELSE IF (ephstr(1:2).eq.'50') THEN
C     Offset from center
        READ (ephstr(3:100),*,err=100) idir,mjd,sod,(vec(k),k=1,3)
        IF (idir .eq. 1) nvoff= nvoff+ 1
        IF (nvoff.gt.MAXENT) THEN
          WRITE (*,*) 'ephemeris read error: too many records'
          GO TO 110
        END IF
        offsetjdi(nvoff)=mjd+2400000.0d0
        offsetjdf(nvoff)=sod/86400.d0+0.5d0
        IF (offsetjdf(nvoff).ge.1.0d0) THEN
          offsetjdi(nvoff)=offsetjdi(nvoff)+1.0d0
          offsetjdf(nvoff)=offsetjdf(nvoff)-1.0d0
        ENDIF
        IF (idir .eq. 1) THEN
          offsetoutv(nv,1)= vec(1)
          offsetoutv(nv,2)= vec(2)
          offsetoutv(nv,3)= vec(3)
        ELSE IF (idir .eq. 2) THEN
          offsetbackv(nv,1)= vec(1)
          offsetbackv(nv,2)= vec(2)
          offsetbackv(nv,3)= vec(3)
        ENDIF

      ELSE IF (ephstr(1:2).eq.'60') THEN
C     Rotation angle
        nvrot= nvrot+ 1
        IF (nvrot.gt.MAXENT) THEN
          WRITE (*,*) 'ephemeris read error: too many records'
          GO TO 110
        END IF
        READ (ephstr(3:100),*,err=100) mjd,sod,(rotangv(nvrot,k),k=1,3),
     x   gast(nvrot)
        rotjdi(nvrot)=mjd+2400000.0d0
        rotjdf(nvrot)=sod/86400.d0+0.5d0
        IF (rotjdf(nvrot).ge.1.0d0) THEN
          rotjdi(nvrot)=rotjdi(nvrot)+1.0d0
          rotjdf(nvrot)=rotjdf(nvrot)-1.0d0
        END IF

      ELSE IF (ephstr(1:2).eq.'70') THEN
C     EOP
        nveop= nveop+ 1
        IF (nveop.gt.MAXENT) THEN
          WRITE (*,*) 'ephemeris read error: too many records'
          GO TO 110
        END IF
        READ (ephstr(3:100),*,err=100) mjd,sod,(eopxy(nveop,k),k=1,2), 
     x   eopdutc(nveop)
        eopjdi(nveop)=mjd+2400000.0d0
        eopjdf(nveop)=sod/86400.d0+0.5d0
        IF (eopjdf(nveop).ge.1.0d0) THEN
          eopjdi(nveop)=eopjdi(nveop)+1.0d0
          eopjdf(nveop)=eopjdf(nveop)-1.0d0
        END IF

      ELSE IF (ephstr(1:2).eq.'99') THEN  
!  Should do something here?
        GO TO 120

      ELSE IF (ephstr(1:1).eq.'#' .or. ephstr(1:2).eq.'00') THEN
!  Comment
      END IF
  
      GO TO 10
  
!     create a small usable time tag
  120 DO i=1,nv
        jds(i)=((jdf(i)-jdf(1))+(jdi(i)-jdi(1)))*86400.d0
C       Convert velocity from m/sec to m/day!
        DO j=4,6
C	write(*,*) 'outv, backv m/day',outv(i,j), backv(i,j)
        END DO
      END DO
      DO i=1,nvoff
        offsetjds(i)=((offsetjdf(i)-offsetjdf(1))+
     &               (offsetjdi(i)-offsetjdi(1)))*86400.d0
      END DO
      DO i=1,nvrot
        rotjds(i)=((rotjdf(i)-rotjdf(1))+
     &               (rotjdi(i)-rotjdi(1)))*86400.d0
      END DO
      DO i=1,nveop
        eopjds(i)=((eopjdf(i)-eopjdf(1))+
     &               (eopjdi(i)-eopjdi(1)))*86400.d0
      END DO
      RETURN
  
  100 WRITE (*,*) 'ephemeris read error'
  110 CONTINUE
      ierr= -1
      if (debug) WRITE (*,*) 'nv=',nv
      RETURN
      END
